﻿using System;
using System.Collections.Generic;
using System.Windows.Input;

namespace Polecenie
{
    class Program
    {
        private static void wykonajPolecenie(ICommand polecenie, object parametr = null)
        {
            if (polecenie.CanExecute(parametr)) polecenie.Execute(parametr);
            else Console.WriteLine("Nie można wykonać polecenia");
        }

        class DanePrzelewu
        {
            public Konto KontoPłatnika;
            public Konto KontoOdbiorcy;
            public decimal Kwota;
            public bool Wykonane = false;
        }

        static void Main(string[] args)
        {
            try //powinno być wokół każdego przelewu osobno
            {
                Konto konto1 = new Konto(1, 100);
                Konto konto2 = new Konto(2, 150);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto1, konto2, 50);
                //ICommand polecenieA = new PoleceniePrzelewu(konto1, konto2, 50);
                //ICommand polecenieB = new PoleceniePrzelewu(konto2, konto1, 100);
                DanePrzelewu daneA = new DanePrzelewu() { KontoPłatnika = konto1, KontoOdbiorcy = konto2, Kwota = 50 };
                DanePrzelewu daneB = new DanePrzelewu() { KontoPłatnika = konto2, KontoOdbiorcy = konto1, Kwota = 100 };

                ICommand polecenie = new RelayCommand(
                    (object parameter) =>
                    {
                        DanePrzelewu dane = parameter as DanePrzelewu;
                        Konto.Przelew(dane.KontoPłatnika, dane.KontoOdbiorcy, dane.Kwota);
                        dane.Wykonane = true;
                    },
                    (object parameter) =>
                    {
                        DanePrzelewu dane = parameter as DanePrzelewu;
                        return !dane.Wykonane && dane.Kwota > 0;
                    });

                wykonajPolecenie(polecenie, daneA);

                //List<IPolecenie> polecenia = new List<IPolecenie>();
                //polecenia.Add(polecenieA);
                //polecenia.Add(polecenieB);
                //foreach (IPolecenie polecenie in polecenia) wykonajPolecenie(polecenie);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto2, konto1, 100);
                wykonajPolecenie(polecenie, daneB);
                wykonajPolecenie(polecenie, daneA);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();
            }
            catch (Exception exc)
            {
                Console.Error.WriteLine("Błąd: " + exc.Message);
            }
        }
    }
}
